using Bp.Sync.BackEnd.Infrastructure.Repositories;
using Bp.Sync.Domain.Entities.Inventories.Bills;
using Bp.Sync.Dto.Results;
using CommonLibrary;
using Dapper;
using EasyNetQ;
using MediatR;
using Microsoft.Extensions.Configuration;
using System;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Vina.Search.Infrastructure.Mappings;

namespace Bp.Sync.BackEnd.Application.Commands.Inventories.Bills.InventoryBills
{
    public class SyncInventoryBillHandler : IRequestHandler<SyncInventoryBillCommand, BaseResult>
    {
        private readonly IDbConnection _dbConnection;
        private readonly IInventoryBillRepository _InventoryBillRepository;
        private readonly IProductRepository _productRepository;
        private readonly IBus _bus;

        public SyncInventoryBillHandler(IConfiguration configuration, IInventoryBillRepository InventoryBillRepository, IBus bus, IProductRepository productRepository)
        {
            var connectionString = configuration.GetConnectionString("InventoryConnection");
            _dbConnection = new SqlConnection(connectionString);
            _InventoryBillRepository = InventoryBillRepository;
            _productRepository = productRepository;
            _bus = bus;
        }

        public async Task<BaseResult> Handle(SyncInventoryBillCommand request, CancellationToken cancellationToken)
        {
            var rs = new BaseResult();

            if (request.Ids.Count() > 1000)
            {
                var length = request.Ids.Count();
                if (length > 0)
                {
                    for (int i = 0; i <= length / 1000; i++)
                    {
                        if (length > i * 1000)
                        {
                            var ids = request.Ids.Skip(i * 100).Take(1000).ToList();
                            if (ids.Count() > 0)
                            {
                                await _bus.SendAsync($"SyncToElasticInventoryBill", ids.ConvertListLongToString());
                            }
                        }
                    }
                }
                return new BaseResult { Result = Result.Success, Message = $"sent {length} orders" };
            }

            if (!request.Ids.Any())
            {
                rs.Message = $"no data to update";
                rs.Result = Dto.Results.Result.Success;
                return rs;
            }
            try
            {
                var p = new Dto.DapperTypes.IdsParam(request.Ids);
                var InventoryBills = await _dbConnection.QueryAsync<InventoryBill>("Sync_InventoryBill_Get_By_List_Id", p, commandType: CommandType.StoredProcedure);
                if (InventoryBills.Any())
                {
                    var billRs = InventoryBills.ToInventoryBills();
                    var rs2 = await _InventoryBillRepository.AddManyAsync(billRs);
                    if (rs2.Result == Result.Success)
                    {
                        await _dbConnection.ExecuteAsync("Synced_InventoryBill_By_List_Id", p, commandType: CommandType.StoredProcedure);
                        rs.Message = $"{billRs.Count()} synced";
                        rs.Result = Result.Success;

                        //cập nhật dữ liệu ngay
                        if (request.Ids.Count() > 0)
                        {
                            var length = request.Ids.Count();
                            if (length > 0)
                            {
                                int j = 0;
                                for (int i = 0; i <= length / 100; i++)
                                {
                                    j++;
                                    if (length > i * 100)
                                    {
                                        var ids = request.Ids.Skip(i * 100).Take(100).ToList();
                                        if (ids.Count() > 0)
                                        {
                                            await _bus.SendAsync($"UpdateInventoryInventoryBill", ids.ConvertListLongToString());
                                        }
                                    }
                                    if (j > 4) j = 0;
                                }
                            }
                        }

                        return rs;
                    }
                    else
                    {
                        rs.Message = $"can not insert db";
                        rs.Result = Result.Success;
                        return rs;
                    }
                }
                else
                {
                    rs.Message = $"no data to update";
                    rs.Result = Result.Success;
                    return rs;
                }
            }
            catch (Exception ex)
            {
                rs.Message = ex.Message.ToString();
                rs.Result = Result.SystemError;
                return rs;
            }
        }
    }
}